#!/usr/bin/env python
# -*- python -*-
import mad, ao, sys, os
import threading, stack
from time import sleep
import pyid3lib

#
# layer.py -- class to manage MP3 play ... but use only OSS :/
#
# Copyright (c) 2004 DEGOIS Damien <damien@degois.info> 
# Licensed under the GNU GPL. For full terms see the file COPYING.
#
# Cf LICENSE provided with those files
#

class MP3(threading.Thread):
    """ Classe de lecture de MP3"""
    def __init__(self ,name=None):
        """ 1 argument : le fichier a lire """
        threading.Thread.__init__(self, target=self.run, name=name, args=() ) 
        self.start()
        self.mf = 0
        self.id3 = None
        self.plz_stop = 0
        self.playin = 0
        self.total_time = 0
        self.current_time = 0
        self.random = 0
        self.orders = []
        self.dev = None
        self.file = ""
        self.stack = stack.Stack()

    def run(self):
        while 1:
            if self.OrdersHandler() == "exit":
                self.stack.flush()
                break


    def OrdersHandler(self,sleeper=1):
        order = ""
        try:
            order = self.orders.pop()
        except:
            1
        if sleeper:
            sleep(0.1)
        if order == "addpl":
            file = self.orders.pop()
            self.addpl(file)
        if order == "play":
            self.play()
        if order == "stop":
            self.stop()
        if order == "bseek" and self.playin:
            self.mf.seek_time(self.mf.current_time()-5000)
        if order == "fseek" and self.playin:
            self.mf.seek_time(self.mf.current_time()+5000)
        if order == "exit":
            self.stack.flush()
            return "exit"
        return order

    def add_recur(self,file):
        list = []
        for root, dirs, files in os.walk(file, topdown=True):
            for name in files:
                (shortname, extension) = os.path.splitext(name)
                if extension == ".mp3" or extension == ".MP3":
                    list.append(os.path.join(root, name))
        list.sort()
        for x in list:
            self.stack.put(x)


    def addpl(self,file):
        if os.path.isdir(file):
            self.add_recur(file)
        else:
            (shortname, extension) = os.path.splitext(file)
            if extension == ".mp3" or extension == ".MP3":
                self.stack.put(file)


        if not self.playin and self.stack.size():
            self.play()
        
    def play(self):
        self.playin = 1
        self.plz_stop = 0
        while self.stack.size() and not self.plz_stop:
            if self.random:
                self._play(self.stack.getrand())
            else:
                self._play(self.stack.get())
        self.plz_stop = 0
        
    def _play(self,file):
        self.file = file
        self.id3 = pyid3lib.tag(file)
        self.mf = mad.MadFile(file)
        if not self.dev:
            self.dev = ao.AudioDevice('oss',rate=self.mf.samplerate())
        self.total_time = self.mf.total_time
        self.current_time = self.mf.current_time
        self.playin = 1
        if not self.dev:
            self.dev = ao.AudioDevice('oss',rate=self.mf.samplerate())
        while 1 and not self.plz_stop :
            order = self.OrdersHandler(0)
            if order == "next":
                break
            if order == "exit":
                self.plz_stop = 1
                self.stack.flush()
            self.current_time = self.mf.current_time
            buf = self.mf.read()
            if buf is None:
                break
            self.dev.play(buf, len(buf))
        self.dev = None
        self.id3 = None
        self.playin = 0
        self.file = ""
    def stop(self,flush=0):
#        if flush:
#            self.stack.flush()
        if self.playin == 1:
            self.plz_stop = 1

        
