#!/usr/bin/python
# -*- python -*-

#
# sound_ctrl.py -- class to manage sound volume
#
# Copyright (c) 2004 DEGOIS Damien <damien@degois.info> 
# Licensed under the GNU GPL. For full terms see the file COPYING.
#
# Cf LICENSE provided with those files
#

import ossaudiodev, threading
from time import sleep

class Mixer(threading.Thread):
    def __init__(self, name=None):
        self.mixer = ossaudiodev.openmixer()
        threading.Thread.__init__(self, target=self.run, name=name, args=() ) 
        self.start()
        self.orders = []

        
    def run(self):
        while 1:
            if self.OrdersHandler() == "exit":
                break

    def OrdersHandler(self,sleeper=1):
        order = ""
        try:
            order = self.orders.pop()
        except:
            1
        if sleeper:
            sleep(0.1)
        if order == "up" or order == "down":
            step = 5
            if step:
                if order == "up":
                    self.up(step)
                if order == "down":
                    self.down(step)
            else:
                if order == "up":
                    self.up()
                if order == "down":
                    self.down()
                
                
        if order == "exit":
            return "exit"
        

    def up(self, step=5):
        (l,r) = self.mixer.get(ossaudiodev.SOUND_MIXER_VOLUME)
        l=l+step
        r=r+step
        if l > 100:
            l=100
        if r>100:
            r=100
        self.mixer.set(ossaudiodev.SOUND_MIXER_VOLUME, (l,r))

    def down(self, step=5):
        (l,r) = self.mixer.get(ossaudiodev.SOUND_MIXER_VOLUME)
        l=l-step
        r=r-step
        if l < 0:
            l=0
        if r < 0:
            r=0
        self.mixer.set(ossaudiodev.SOUND_MIXER_VOLUME, (l,r))

    def get(self):
        return self.mixer.get(ossaudiodev.SOUND_MIXER_VOLUME)

    def set(self,val1,val2=None):
        if not val2:
            val2 = val1

        if val1 < 0:
            val1=0
        if val1 > 100:
            val1=100

        if val2 < 0:
            val2=0
        if val2 > 100:
            val2=100
        self.mixer.set(ossaudiodev.SOUND_MIXER_VOLUME, (val1,val2))
