#!/usr/bin/python
# -*- python -*-

#
# stack.py -- small class to manage stack FIFO
#
# Copyright (c) 2004 DEGOIS Damien <damien@degois.info> 
# Licensed under the GNU GPL. For full terms see the file COPYING.
#
# Cf LICENSE provided with those files
#
import random

class Stack:
    """ Classe de pile FIFO : cf get & put"""
    def __init__(self):
        """ Classe de pile FIFO : cf get & put"""
        self.stack = []

    def get(self):
        """ Retourne une valeur de la pile (la premiere) """
        ret = ""
        try:
            ret = self.stack.pop()
        except:
            ret = None
        return ret

    def getrand(self):
        """ Retourne une valeur de la pile (n'importe) """
        ret = ""
        try:
            ret = self.stack.pop(random.randrange(0,self.size()))
        except:
            ret = None
        return ret

    def put(self,val):
        """ Ajoute une valeur a la pile (la derniere)"""
        self.stack.insert(0,val)

    def size(self):
        return len(self.stack)

    def flush(self):
        self.stack = []

